%%% Enrico Antonio Jeh Molento de Moraes   9838219
%%% Classificador nao linear - PTC3569 - Professor Ademar Ferreira

clc
clear all
close all
%% Carregar entradas e labels: Descomentar dependendo do numero de entradas!
%Data_treino = load ('treina.txt');  %txt com 4 entradas
%Data_teste = load ('teste.txt');
Data_treino = load ('treina1.txt'); %txt com 9 entradas
Data_teste = load ('teste1.txt');

% Dados_treino = Data_treino(:,1:9); %leitura dos dados de treinamento, 9 entradas
% Alvos_treino = Data_treino(:,10)'; 
% Dados_teste = Data_teste(:,1:9); %leitura dos dados de teste e excluso da linha 5 no arquivo de teste
% Alvos_teste = Data_teste(:,10)';  %classes verdadeiras do teste

Dados_treino = Data_treino(:,1:4); %4 entradas
Alvos_treino = Data_treino(:,5)'; 
Dados_teste = Data_teste(:,1:4); 
Alvos_teste = Data_teste(:,5)';  

%% Tratar dados
Max_alvos_treino=max(max(Alvos_treino));  % salva os pontos para desnormalizar depois
Min_alvos_treino=min(min(Alvos_treino));    
Max_alvos_teste=max(max(Alvos_teste));    
Min_alvos_teste=min(min(Alvos_teste));

Dados_treino=normaliza(Dados_treino,-1,1);% Normalizando dados para media nula e variancia unitaria
Alvos_treino=normaliza(Alvos_treino,-1,1);
Dados_teste = normaliza(Dados_teste,-1,1);
Alvos_teste = normaliza(Alvos_teste,-1,1);
%% Parametros da rede neural: escolher o numero de neurnios na entrada (4 ou 9) e hidden (5 ou 10)
 N1 = 4;
 N0 = 4+1;   % Para 4 entradas
% Para 9 entradas:
% N1=9;        % Neuronios da camada escondida      
% N0=9+1;      % Neuronios da camada de entrada + bias
 
 N2=1;      % Neuronio de saida 
% Parametros de treinamento
LR = 0.025; % Taxa de aprendizado (Learning rate)
iteracoes = 1000;  % Iteraoes
momentum = 0; % termo de momento, se desejado

% Inicializao dos pesos aleatorios
w1=randn(N1,N0);    % Conexao entre a camada escondida e de entrada
w2=randn(N2,N1);    % Conexao entre a camada escondida e de saida

%%%%%Treinamento da rede%%%%%%%%
for j=1:iteracoes

    indicealeatorio(j,:)=randperm(length(Alvos_treino)); 
    % randomizar os dados de treinamento para melhorar o aprendizado
    w1_M = w1;     %cria vetor que armazena os pesos para usar momentum
    w2_M = w2;
        
    for k=1:size(Dados_treino,1)
        
        Input=[1 Dados_treino(indicealeatorio(j,k),:)];  % {1} is for bias
        
        % Camada de entrada
        aux1 = w1*Input';
        a1=tansig(aux1);  %aplicaao da funao de ativaao tanh(x) nas camadas

        % Camada escondida
        aux2 = w2*a1;
        a2=tansig(aux2); 
        
        % Camada de saida
        Output_treino(k)=a2;    
        e = Alvos_treino(indicealeatorio(j,k)) - Output_treino(k);
        
        % BackPropagation        
        Y2 = 2*dtansig(aux2,a2)*e;  % Gradiente da camada de saida
        Y1 = diag(dtansig(aux1,a1),0)*w2'*Y2; % Gradiente da camada escondida na diagonal
                                              % principal para multiplicar em seguida       
        w1 = w1 + LR*Y1*Input + momentum*w1_M;  % Pesos da camada de entrada atualizados
        w2 = w2 + LR*Y2*a1' + momentum*w2_M;    % Pesos da camada escondida atualizados
                                                % com termo de momentum  
        SE(j,k)= e*e';      % Erro quadratico
    end
    
MSE(j)=mean(SE(j,:));       % Erro quadratico mdio (gradient descent)

% Taxa de acertos
Acuracia(j)=length(find((round(Output_treino)-Alvos_treino(indicealeatorio(j,:)))==0))*100/length(Output_treino);
end

Output_treino = normaliza(Output_treino,Min_alvos_treino,Max_alvos_treino); %%Desnormalizar a sada
Alvos_treino = normaliza(Alvos_treino,Min_alvos_treino,Max_alvos_treino); 
% caso na haja a desnormalizao, as amostras estaro em -1, 0 ou 1

%%%%plotagem do treinamento%%%%%
figure
semilogy(MSE)
xlabel('Iteraoes de treinamento')
ylabel('MSE (dB)')
title('Funo objetivo pelo MSE')

figure
plot(Acuracia)
xlabel('Iteracoes de treinamento')
ylabel('Acuracia(%)')
title('Performance de classificaao no treinamento')

figure
plot(Alvos_treino(indicealeatorio(j,:)),'or')
hold on
plot(round(Output_treino))

legend('Classe verdadeira','Prediao do Perceptron')
xlabel('Amostra de treino#')
ylabel('Eixo de Classes')
title('Performance de Classificaao (Treinamento)')

Acuracia_treino=length(find((round(Output_treino)-Alvos_treino(indicealeatorio(j,:)))==0))*100/length(Output_treino);

%%%%%%%%%% Teste da rede com novas entradas %%%%%%%%
Output=[];

for k=1:size(Dados_teste,1)

        Input=[1 Dados_teste(k,:)];
       
        aux1 = w1*Input';     
        a1=tansig(aux1);    %  ativao: tansig para [-1,+1] e logsig para[0,1] 
%         
        aux2 = w2*a1;
        a2=tansig(aux2);    % ativao da camada de sada
        
        Output(k)=a2;              

end
Output = normaliza(Output,Min_alvos_teste,Max_alvos_teste); %%Desnormalizar a sada
Alvos_teste = normaliza(Alvos_teste,Min_alvos_teste,Max_alvos_teste); 
% caso na haja a desnormalizao, as amostras estaro em -1, 0 ou 1  

%plotagem do resultado do teste 
figure
plot(Alvos_teste,'or')
hold on
plot(round(Output))
legend('Classe verdadeira','Prediao do Perceptron')
xlabel('Amostra #')
ylabel('Eixo de Classes')
title('Performance da classificao (teste)')

Acuracia_teste=length(find((round(Output)-Alvos_teste)==0))*100/length(Output);

Acuracia_treino
Acuracia_teste

